/*
 * Created on 04.01.2008
 */
package dsasolo;

public class Kampf extends Skript{
	
	int anzahlGegner;
	String AT;
	String PA;
	int wuerfelTP;
	int modTP;
	String lep;
	String maxLep;
	String minLep;
	String RS;
	boolean gegnerbeginnt;
	boolean ergeben;
	boolean unbewaffnet;
	int finte;
	int wuchtschlag;
	int sieg;
	String textSieg;
	int niederlage;
	String textNiederlage;
	String textErgeben = "Ich ergebe mich.";
	
	public Kampf(String []param, int nr){
		this.nr = nr;
		int z = 0;
		//Bei 19 Parametern ist eine Anzahl an Gegnern mitgegeben in param[1]
		if(param.length == 19) {
			z = 1;
		}
		this.name = param[0];
		if(z == 1) {
			this.anzahlGegner = wandleZahl(param[1]);
		}else {
			this.anzahlGegner = 1;
		}
		this.AT = param[z+1];
		this.PA = param[z+2];
		this.wuerfelTP = wandleZahl(param[z+3]);
		this.modTP = wandleZahl(param[z+4]);
		this.lep = param[z+5];
		this.maxLep = param[z+6];
		this.minLep = param[z+7];
		this.RS = param[z+8];
		if(wandleZahl(param[z+9]) == 0)
			this.gegnerbeginnt = true;
		else
			this.gegnerbeginnt = false;
		if(param[z+10].equals("ja"))
			this.ergeben = true;
		else
			this.ergeben = false;
		if(param[z+11].equals("ja"))
			this.unbewaffnet = false;
		else
			this.unbewaffnet = true;
		this.finte = wandleZahl(param[z+12]);
		this.wuchtschlag = wandleZahl(param[z+13]);
		this.sieg = wandleZahl(param[z+14]);
		this.textSieg = param[z+15];
		this.niederlage = wandleZahl(param[z+16]);
		this.textNiederlage = param[z+17];
		baustein = setzeKampftabelle();
	}
	
	public String toString(){
		return "Kampf: wenn gewonnen, dann ["+sieg+"], ansonsten ["+niederlage+"]";
	}

	public String gibSkript(){
		String kampf = " beginneKampf"+(anzahlGegner>1?"Mehrere":"")+"("+AT+", "+PA+", "+wuerfelTP+", "+modTP+", "+lep+", "+maxLep+", "+minLep+", "+RS+", "+(gegnerbeginnt?0:1)+(anzahlGegner>1?", "+anzahlGegner:"")+"); "+ 
				"document.getElementById('w1a"+nr+"').innerHTML = ''; " + 
				"document.getElementById('LINK"+nr+"ende').style.display = 'none'; " + 
				"document.getElementById('LINK"+nr+"kampfunfaehig').style.display = 'none'; " + 
				"document.getElementById('LINK"+nr+"ergeben').style.display = '"+(ergeben?"block":"none")+"'; " + 
				"document.getElementById('kampf"+nr+"').disabled = false; " + 
				"document.getElementById('kampf"+nr+"').value = ' Kampf! '; " + 
				"document.getElementById('t1a"+nr+"').innerHTML = '&nbsp;<br>&nbsp;'; " + 
				"document.getElementById('t2a"+nr+"').innerHTML = '&nbsp;<br>&nbsp;'; " + 
				"document.getElementById('gegner"+nr+"_0').src = '../Bilder/Gegner1.png';" +
				(anzahlGegner>1?"document.getElementById('gegner"+nr+"_1').src = '../Bilder/Gegner2.png';":"") +
				(anzahlGegner>2?"document.getElementById('gegner"+nr+"_2').src = '../Bilder/Gegner3.png';":"");
		return kampf;
	}
	
	String setzeKampftabelle(){
		String text = "				<table align=\"center\" style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n"  +
					  "						<td><b id=\"name\"></b></td>\r\n" +
					  "						<td><b>Gegner</b></td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<table align=\"center\" style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  (anzahlGegner>1?"						<td>&nbsp;</td>\r\n":"") +
					  "						<td id=\"w1a"+nr+"\" class=\"wuerfel1\">&nbsp;</td>\r\n" +
					  (anzahlGegner>1?"						<td>&nbsp;</td>\r\n":"") +
					  "						<td>&nbsp;</td>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  "						<td style=\"width:64px;\"><img id=\"gegner"+nr+"_0\" src=\"../Bilder/Gegner1.png\" width=64 height=68 border=0>"+(anzahlGegner>1?"1":"")+"</td>\r\n" +
					  (anzahlGegner>1?"						<td style=\"width:64px;\"><img id=\"gegner"+nr+"_1\" src=\"../Bilder/Gegner1.png\" width=64 height=68 border=0>2</td>\r\n":"") +
					  (anzahlGegner>2?"						<td style=\"width:64px;\"><img id=\"gegner"+nr+"_2\" src=\"../Bilder/Gegner1.png\" width=64 height=68 border=0>3</td>\r\n":"") +
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<table align=\"center\" style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n" +
					  "						<td id=\"t1a"+nr+"\">&nbsp;<br>&nbsp;</td>\r\n" +
					  "						<td id=\"t2a"+nr+"\">&nbsp;<br>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<table align=\"center\" style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n" +
					  "						<td><input id=\"kampf"+nr+"\" type=\"button\" value=\" Kampf! \" onfocus=\"blur()\" onclick=\"wuerfelKampf("+nr+")\"></td>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<table align=\"center\" border=0 style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n" +
					  "						<td width=50% colspan=2><b>Angriffsoptionen</b></td>\r\n" +
					  "						<td width=50%>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "					<tr>\r\n" +
					  "						<td class=\"left\"><input id=\"cbKeinesBasis"+nr+"\" type=\"radio\" selected=\"true\" name=\"basismanoever\" value=\"0\" onfocus=\"blur()\" onclick=\"setzeKeinesBasis("+nr+")\"><label id=\"KeinesBasis"+nr+"Text\" for=\"cbKeinesBasis"+nr+"\"> Keines</label></td>\r\n" +
					  "						<td class=\"right\">\r\n" +
					  "							<input id=\"KeinesBasis"+nr+"\" disabled=\"true\" value=\"0\" type=\"hidden\" size=\"2\" maxlength=\"2\">\r\n" +
					  "						</td>\r\n" +		
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "					<tr>\r\n" +
					  "						<td class=\"left\"><input id=\"cbFinte"+nr+"\" type=\"radio\" name=\"basismanoever\" value=\"0\" onfocus=\"blur()\" onclick=\"setzeFinte(0, "+nr+")\"><label id=\"Finte"+nr+"Text\" for=\"cbFinte"+nr+"\"> Finte</label></td>\r\n" +
					  "						<td class=\"right\">\r\n" +
					  "							<input id=\"bFinteMinus"+nr+"\" type=\"button\" disabled=\"true\" value=\"-\" onfocus=\"blur()\" onclick=\"setzeFinte(-1, "+nr+")\">\r\n" +
					  "							<label id=\"Finte"+nr+"\" for=\"cbFinte"+nr+"\">I</label>\r\n" + 
					  "							<input id=\"bFintePlus"+nr+"\" type=\"button\" value=\"+\" onfocus=\"blur()\" onclick=\"setzeFinte(1, "+nr+")\">\r\n" +
					  "						</td>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "					<tr>\r\n" +
					  "						<td class=\"left\"><input type=\"radio\" name=\"basismanoever\" id=\"cbWuchtschlag"+nr+"\" value=\"0\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(0, "+nr+")\"><label id=\"Wuchtschlag"+nr+"Text\" for=\"cbWuchtschlag"+nr+"\"> Wuchtschlag</label></td>\r\n" + 
					  "						<td class=\"right\">\r\n" +
					  "							<input id=\"bWuchtschlagMinus"+nr+"\" type=\"button\" disabled=\"true\" value=\"-\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(-1, "+nr+")\">\r\n" +
					  "							<label id=\"Wuchtschlag"+nr+"\" for=\"cbWuchtschlag"+nr+"\">I</label>\r\n" + 
					  "							<input id=\"bWuchtschlagPlus"+nr+"\" type=\"button\" value=\"+\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(1, "+nr+")\">\r\n" +
					  "						</td>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<table align=\"center\" style=\"table-layout:fixed\" width=60%>\r\n" +
					  "					<tr>\r\n" +
					  "						<td><button id=\"buttonAuto"+nr+"\" type=\"button\" value=\" Automatischer Kampf \" onfocus=\"blur()\" onclick=\"kaempfeAuto("+nr+")\"><font size=\"-2\">Automatischer Kampf</font></button></td>\r\n" +
					  "						<td>&nbsp;</td>\r\n" +
					  "					</tr>\r\n" +
					  "				</table>\r\n" +
					  "\r\n" +
					  "				<div id=\"LINK"+nr+"ende\" style=\"display: none\">\r\n" + 
					  "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+sieg+"').click(); setzeText("+nr+", "+sieg+")\">"+textSieg+" ["+sieg+"]</button>\r\n" +
					  "				</div>\r\n" +
					  "\r\n" +
					  "				<div id=\"LINK"+nr+"kampfunfaehig\" style=\"display: none\">\r\n" + 
					  "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+niederlage+"').click(); setzeText("+nr+", "+niederlage+")\">"+textNiederlage+" ["+niederlage+"]</button>\r\n" +
					  "				</div>\r\n" +
					  "\r\n" +
					  "				<div id=\"LINK"+nr+"ergeben\" style=\"display: "+(ergeben?"block":"none")+"\">\r\n" + 
					  (ergeben?"					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+niederlage+"').click(); setzeText("+nr+", "+niederlage+")\">Ich ergebe mich. ["+niederlage+"]</button>\r\n":"") +
					  "				</div>\r\n";
		return text;
	}
	
}
